this.name        = "Pi-Forty-Two Con stores"; 
this.author      = "Ark"; 
this.copyright   = "� 2009 the Oolite team."; 
this.description = "This script places constore stations near witchspace boys and also one asteroid billboard when the populator can not add at least one of them."; 
this.version     = "4.1.7"; 

this.shipExitedWitchspace = function () 
{ 
   this.addConstoreIfPossible(); 
   this.addAsteroidbillboardIfPossible();
} 

this.shipWillLaunchFromStation = function () 
{ 
   this.addConstoreIfPossible(); 
   this.addAsteroidbillboardIfPossible();
   delete this.shipWillLaunchFromStation; // only add stations on the first launch after startup or reload.
} 

this.addConstoreIfPossible = function () 
{ 
   if (system.government > 0 && !system.isInterstellarSpace && !system.sun.isGoingNova && system.population > 40)
   { 
        var constore = this.addShipsNoRings("constore", 1, [0, 5E3, -30E3], 10E3)[0]; 
        constore.orientation = [1,0,1,0]; // Orientate the side to the main planet for best view from the spacelane.
        this.addShipsNoRings("constore-buoy", 1, constore.position.add(constore.heading.multiply(10E3)), 1);
   } 
}

this.addAsteroidbillboardIfPossible = function ()
{ 
   if (system.government === 7 && !system.isInterstellarSpace) 
   { 
       var billboard = system.addShipsToRoute("asteroid-billboard", 1, Math.random()*0.5 + 0.25, 'sp')[0];
       system.addShips("asteroid", 8, billboard.position, 10E3);
       billboard.orientation = Quaternion.random();
   } 
}

this.addShipsNoRings = function (role,count,position,radius) { 
   var offset =new Vector3D(0,50000,0);
   var ships=system.addShips(role, count, offset,radius); 
   offset=new Vector3D(position).subtract(offset); 
   var i=0; 
   while (i < ships.length) 
   { 
      ships[i].position=ships[i].position.add(offset); 
      i++; 
   } 
   return ships; 
}